#include "NMEA_rk.h"


static DWORD f_time;

//struktura ramki GPRMC
struct GPRMC
{
	char time[UTC_time_size+2];
	char Status;
	char Latitude[Latitude_size+2];
	//char NSIndicator;
	char Longtitude[Longtitude_size+2];
	//char EWIndicator;
	//char Speed[Speed_size+2];
	//char Course[Course_size+2]; 
	char Date[Date_size+2];
	//char MVariation[Mvariation_size+2];
	//char MVariation_indicator;
	//char Mode;
	char CRC[3];
	
	unsigned int fractional_lat;
	unsigned int fractional_long;
	
} GP_RMC;

char get_RMC_frame(char* buff)
{
	char znak_uart;
	char flaga_pomocnicza=0;
	char counter=0;
	
	buff[0]=0;
	
	while(1)
	{
		znak_uart=usart_receive();	
		
		if (znak_uart == '$') //znak poczatku ramki
		{
			flaga_pomocnicza = 1 ;
			counter=0;
			buff[counter++]='$';	
			continue;
		}
		
		
		if (flaga_pomocnicza == 1) //oczekuj na nagwek RMC
		{
			switch (counter)
			{
				case 1:
					if (znak_uart == 'G')
						buff[counter++]=znak_uart;
					else 
						flaga_pomocnicza=0;
					
					break;
				case 2:
					if (znak_uart == 'P')
						buff[counter++]=znak_uart;
					else 
						flaga_pomocnicza=0;
						
					break;
				case 3:
					if (znak_uart == 'R')
						buff[counter++]=znak_uart;
					else 
						flaga_pomocnicza=0;
						
					break;
				case 4:
					if (znak_uart == 'M')
						buff[counter++]=znak_uart;
					else 
						flaga_pomocnicza=0;
						
					break;
				case 5:
					if (znak_uart == 'C')
					{
							buff[counter++]=znak_uart;	
							flaga_pomocnicza=2;
							continue;
					}
					else 
						flaga_pomocnicza=0;
											
					break;
			}
		}	

		if (flaga_pomocnicza == 2) 
			buff[counter++]=znak_uart;
			
		if (znak_uart==10) 
		{
			if (flaga_pomocnicza==2)
				return 1;
			else
				return 0;
		}	
		
			
	}	
}	
	
struct GPRMC divide_frame(char* buff)
{
	char* tmp_pointer1;
	
	tmp_pointer1 = strstr(buff,",")+1; //UTC TIME
	strncpy(GP_RMC.time,tmp_pointer1,6);
	GP_RMC.time[6]=0;
	
	tmp_pointer1 = strstr(tmp_pointer1,",")+1; //Status
	GP_RMC.Status=*tmp_pointer1;
	
	tmp_pointer1 = strstr(tmp_pointer1,",")+1; //poczatek Latitude
	strncpy(GP_RMC.Latitude,tmp_pointer1,9);
	GP_RMC.Latitude[9]=0;
	
	tmp_pointer1 = strstr(tmp_pointer1,",")+1; // NS Indicator nie uywam
	
	tmp_pointer1 = strstr(tmp_pointer1,",")+1; // Longtitude
	strncpy(GP_RMC.Longtitude,tmp_pointer1,10);
	GP_RMC.Longtitude[10]=0;
	
	tmp_pointer1 = strstr(tmp_pointer1,",")+1; // EW Indicator nie uywam
	tmp_pointer1 = strstr(tmp_pointer1,",")+1; // Speed nie uywam
	tmp_pointer1 = strstr(tmp_pointer1,",")+1; // Course over ground nie uywam
	tmp_pointer1 = strstr(tmp_pointer1,",")+1; // Data
	strncpy(GP_RMC.Date,tmp_pointer1,6);
	GP_RMC.Date[6]=0;
	
	tmp_pointer1 = strstr(buff,"*")+1; // CRC 
	strncpy(GP_RMC.CRC,tmp_pointer1,2);
	GP_RMC.CRC[2]=0;
	
	
	//Modyfikacja LONGTITUDE i LATITUDE (wyodrebnienie czesi ulamkowych) 
	
	
	GP_RMC.fractional_lat=1000*(GP_RMC.Latitude[5]-48);
	GP_RMC.fractional_lat+=100*(GP_RMC.Latitude[6]-48);
	GP_RMC.fractional_lat+=10 *(GP_RMC.Latitude[7]-48);
	GP_RMC.fractional_lat+=    (GP_RMC.Latitude[8]-48);
	
	GP_RMC.fractional_long=1000*(GP_RMC.Longtitude[6]-48);
	GP_RMC.fractional_long+=100*(GP_RMC.Longtitude[7]-48);
	GP_RMC.fractional_long+=10 *(GP_RMC.Longtitude[8]-48);
	GP_RMC.fractional_long+=    (GP_RMC.Longtitude[9]-48);
	
	//Modyfikacja czasu UTC do czasu Polskiego
	
	GP_RMC.time[1] +=1;
	if (GP_RMC.time[1] > 57) 
	{
		GP_RMC.time[1]='0';
		GP_RMC.time[0] +=1;
	}
	
	if ((GP_RMC.time[0] == '2') && (GP_RMC.time[1] == '5'))
	{
		GP_RMC.time[0]='0';
		GP_RMC.time[1]='0';
	}
		
	
	
}

//0 ustawia, 1 zwraca
DWORD get_fattime (bool mode)
{
	DWORD tmp;
	if (mode ==1 ) return f_time;
	
	//31:25 data
	f_time =((((GP_RMC.Date[4]-48)*10) + GP_RMC.Date[5] - 28 ));
	f_time <<=25;
	
	//24:21 Miesiac
	tmp = ((((GP_RMC.Date[2]-48)*10) + GP_RMC.Date[3]-48));
	tmp <<=21;
	f_time |= tmp;
	
	
	//20:16 dzien
	tmp = ((((GP_RMC.Date[0]-48)*10) + GP_RMC.Date[1] -48));
	tmp <<=16;
	f_time |= tmp;


	//15:11 godzina
	tmp = ((((GP_RMC.time[0]-48)*10) + GP_RMC.time[1] -48));
	tmp <<=11;
	f_time |=tmp;
	
	//10:5 minuty
	tmp = ((((GP_RMC.time[2]-48)*10) + GP_RMC.time[3]-48));
	tmp<<=5;
	f_time |= tmp;
	
	return f_time; 
}	
 