#ifndef PORT_CONF_H_
#define PORT_CONF_H_

#include "avr/io.h"
#include "uart.h"
#include "timers.h"
#include "avr/interrupt.h"
#include "avr/signal.h"
#endif /* PORT_CONF_H_ */

#define set_bit(port,pin) (port |= 1<<pin)
#define clr_bit(port,pin) (port &= ~(1<<pin))
#define tg_bit(port,pin) (port ^= 1<<pin)

#define pin_state(PINx,pin) (PINx & 1<<pin)


#define F_CPU 8000000
#define baud 9600
#define uart_rate (F_CPU / 16 / baud -1)

#define led1_port PORTC
#define led1_pin 1

#define led2_port PORTC
#define led2_pin 3

#define led3_port PORTC
#define led3_pin 2

#define device_on PORTD |= 1<<6
#define device_off  PORTD &= ~(1<<6)

#define led1_on set_bit(led1_port,led1_pin)
#define led1_off clr_bit(led1_port,led1_pin)
#define led1_tg tg_bit(led1_port,led1_pin)

#define led2_on set_bit(led2_port,led2_pin)
#define led2_off clr_bit(led2_port,led2_pin)
#define led2_tg tg_bit(led2_port,led2_pin)

#define led3_on set_bit(led3_port,led3_pin)
#define led3_off clr_bit(led3_port,led3_pin)
#define led3_tg tg_bit(led3_port,led3_pin)

#define gps_pwr_port PORTA
#define gps_pwr_pin 7
#define gps_fix_port PINB
#define gps_fix_pin 0
#define gps_on clr_bit(gps_pwr_port,gps_pwr_pin)
#define gps_off set_bit(gps_pwr_port,gps_pwr_pin)
#define fix_state pin_state(gps_fix_port,gps_fix_pin) 

#define SD_power_port PORTB
#define SD_power_pin 1
#define card_on clr_bit(SD_power_port,SD_power_pin)
#define card_off set_bit(SD_power_port,SD_power_pin)

#define WP_PIN PIND
#define WP_pin 5 

#define CD_PIN PIND
#define CD_pin 6



#define MISO_DDR DDRB
#define MISO_pin 4
#define MOSI_DDR DDRB
#define MOSI_pin 3
#define CLK_DDR DDRB
#define CLK_pin 5
#define SS_DDR DDRB
#define SS_pin 2

void port_init(void);