#include "uart.h"


void usart_init(int val)
{
	/* Set baud rate */
	UBRRH = (unsigned char)(val>>8);
	UBRRL = (unsigned char)val;
	/* Enable receiver and transmitter */
	UCSRB =   (1<<RXEN) | (1<<TXEN);
	/* Set frame format: 8data, 1stop bit */
	UCSRC = (1<<URSEL)|(3<<UCSZ0) ;//| 1<<UCPOL;
 	 

}	 



void usart_char( unsigned char data )
{
	/* Wait for empty transmit buffer */
	while ( !( UCSRA & (1<<UDRE)) );
	/* Put data into buffer, sends the data */
	UDR = data;
}


void usart_string(char *str)      
{
 	while(*str) usart_char(*str++);
}



unsigned char usart_receive( void )
{
	/* Wait for data to be received */
	while ( !(UCSRA & (1<<RXC)) );
	/* Get and return received data from buffer */
	return UDR;
}

void send_bin_byte(char data)
{
	char tmp=data;
	char i;
	

	//usart_string("Wartosc bin: ");
	
	for(i=0;i<8;i++)
	{
		if ((tmp & 0x80) == 0x80)
			usart_char('1');
		else
			usart_char('0');
			
		tmp <<=1;
		
		
	}
	//usart_string("\n\r");
}

void send_bin_int(int data)
{
	int tmp=data;
	char i;
	

	//usart_string("Wartosc bin: ");
	
	for(i=0;i<16;i++)
	{
		if ((tmp & 0x8000) == 0x8000)
			usart_char('1');
		else
			usart_char('0');
			
		tmp <<=1;
		
		
	}
	//usart_string("\n\r");
}
